<?php

namespace AppBundle\Entity\Organization;

use AppBundle\Entity\AccessAndFunction\Access;
use AppBundle\Entity\Organization\OnlineRegistrationSettings;
use AppBundle\Entity\Organization\Organization;
use AppBundle\Entity\Traits\ActivityPeriodTrait;
use Doctrine\ORM\Mapping as ORM;
use Dunglas\ApiBundle\Annotation\Iri;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\Validator\Constraints as Assert;
use AppBundle\Entity\Traits\TimestampableEntity;
use AppBundle\Entity\Traits\CreatorUpdaterEntity;

/**
 * OnlineRegistrationDocument.
 *
 * @see http://schema.org/OnlineRegistrationDocument Documentation on Schema.org
 *
 * @Iri("http://schema.org/OnlineRegistrationDocument")
 */
#[ORM\Entity]
class OnlineRegistrationDocument
{
    use TimestampableEntity;
    use CreatorUpdaterEntity;
    /**
     * @var int
     */
    #[ORM\Column(type: 'integer')]
    #[ORM\Id]
    #[ORM\GeneratedValue(strategy: 'AUTO')]
    #[Groups(['onlineregistrationdocument', 'onlineregistrationsettings_edit_onlineregistrationsettings', 'onlineregistration_infos'])]
    private $id;
    /**
     * @var OnlineRegistrationSettings
     */
    #[ORM\ManyToOne(targetEntity: 'OnlineRegistrationSettings', inversedBy: 'documents')]
    #[ORM\JoinColumn(nullable: true)]
    #[Groups(['onlineregistrationdocument'])]
    private $onlineRegistrationSettings;
    /**
     * @var OnlineRegistrationSettings
     */
    #[ORM\ManyToOne(targetEntity: 'OnlineRegistrationSettings', inversedBy: 'guardiansDocuments')]
    #[ORM\JoinColumn(nullable: true)]
    #[Groups(['onlineregistrationdocument'])]
    private $guardiansOnlineRegistrationSettings;
    /**
     * @var string
     */
    #[ORM\Column(type: 'string', nullable: true)]
    #[Assert\Type(type: 'string')]
    #[Groups(['onlineregistrationdocument', 'onlineregistrationsettings_edit_onlineregistrationsettings', 'onlineregistration_infos_documents', 'onlineregistration_infos_guardiansdocuments'])]
    private $label;
    /**
     * @var string
     */
    #[ORM\Column(type: 'string', nullable: true)]
    #[Assert\Type(type: 'string')]
    #[Groups(['onlineregistrationdocument', 'onlineregistrationsettings_edit_onlineregistrationsettings', 'onlineregistration_infos_documents', 'onlineregistration_infos_guardiansdocuments'])]
    private $type;
    /**
     * @var string
     */
    #[ORM\Column(type: 'text', nullable: true)]
    #[Assert\Type(type: 'string')]
    #[Groups(['onlineregistrationdocument', 'onlineregistrationsettings_edit_onlineregistrationsettings', 'onlineregistration_infos_documents', 'onlineregistration_infos_guardiansdocuments'])]
    private $description;
    /**
     * @var bool
     */
    #[ORM\Column(type: 'boolean', options: ['default' => false])]
    #[Assert\Type(type: 'boolean')]
    #[Assert\NotNull]
    #[Groups(['onlineregistrationdocument', 'onlineregistrationsettings_edit_onlineregistrationsettings', 'onlineregistration_infos_documents', 'onlineregistration_infos_guardiansdocuments'])]
    private $isRequired = false;
    /**
     * Sets id.
     *
     * @param int $id
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }
    /**
     * Gets id.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set startDate
     *
     * @param \DateTime $startDate
     *
     * @return onlineregistrationdocument
     */
    public function setStartDate($startDate)
    {
        $this->startDate = $startDate;

        return $this;
    }
    /**
     * Get startDate
     *
     * @return \DateTime
     */
    public function getStartDate()
    {
        return $this->startDate;
    }
    /**
     * Set endDate
     *
     * @param \DateTime $endDate
     *
     * @return onlineregistrationdocument
     */
    public function setEndDate($endDate)
    {
        $this->endDate = $endDate;

        return $this;
    }
    /**
     * Get endDate
     *
     * @return \DateTime
     */
    public function getEndDate()
    {
        return $this->endDate;
    }
    /**
     * Set onlineRegistrationSettings
     *
     * @param \AppBundle\Entity\Organization\OnlineRegistrationSettings $onlineRegistrationSettings
     *
     * @return onlineregistrationdocument
     */
    public function setOnlineRegistrationSettings(\AppBundle\Entity\Organization\OnlineRegistrationSettings $onlineRegistrationSettings)
    {
        $this->onlineRegistrationSettings = $onlineRegistrationSettings;

        return $this;
    }
    /**
     * Get onlineRegistrationSettings
     *
     * @return \AppBundle\Entity\Organization\OnlineRegistrationSettings
     */
    public function getOnlineRegistrationSettings()
    {
        return $this->onlineRegistrationSettings;
    }
    /**
     * Set label
     *
     * @param string $label
     *
     * @return OnlineRegistrationDocument
     */
    public function setLabel($label)
    {
        $this->label = $label;

        return $this;
    }
    /**
     * Get label
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }
    /**
     * Set type
     *
     * @param string $type
     *
     * @return OnlineRegistrationDocument
     */
    public function setType($type)
    {
        $this->type = $type;

        return $this;
    }
    /**
     * Get type
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set description
     *
     * @param string $description
     *
     * @return OnlineRegistrationDocument
     */
    public function setDescription($description)
    {
        $this->description = $description;

        return $this;
    }
    /**
     * Get description
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set isRequired
     *
     * @param boolean $isRequired
     *
     * @return OnlineRegistrationDocument
     */
    public function setIsRequired($isRequired)
    {
        $this->isRequired = $isRequired;

        return $this;
    }
    /**
     * Get isRequired
     *
     * @return boolean
     */
    public function getIsRequired()
    {
        return $this->isRequired;
    }
    /**
     * Set guardiansOnlineRegistrationSettings
     *
     * @param \AppBundle\Entity\Organization\OnlineRegistrationSettings $guardiansOnlineRegistrationSettings
     *
     * @return OnlineRegistrationDocument
     */
    public function setGuardiansOnlineRegistrationSettings(\AppBundle\Entity\Organization\OnlineRegistrationSettings $guardiansOnlineRegistrationSettings)
    {
        $this->guardiansOnlineRegistrationSettings = $guardiansOnlineRegistrationSettings;

        return $this;
    }
    /**
     * Get guardiansOnlineRegistrationSettings
     *
     * @return \AppBundle\Entity\Organization\OnlineRegistrationSettings
     */
    public function getGuardiansOnlineRegistrationSettings()
    {
        return $this->guardiansOnlineRegistrationSettings;
    }
}
